from fastapi import APIRouter, HTTPException  # 从 FastAPI 中导入 APIRouter，用于创建 API 路由器

from src.backtest.service import start_backtest_service
from src.pydantic.backtest_request import BackRequest

router = APIRouter()  # 创建一个 FastAPI 路由器实例


@router.get("/start_backtest")
async def start_backtest(request: BackRequest):
    result = await start_backtest_service(field_list=['close', 'time'],
                                          stock_list=request.stock_list,
                                          period=request.period,
                                          start_time=request.start_time,
                                          end_time=request.end_time,
                                          count=request.count,
                                          dividend_type=request.dividend_type,
                                          fill_data=request.fill_data,
                                          ma_type=request.ma_type,
                                          short_window=request.short_window,
                                          long_window=request.long_window
                                          )
    return result
